/* gencode.c
   code generator som-c		2 Jan 2004
	improve clean, not gen when empty body  14 Mar 2004
	SQL where clause parser  		14 Feb 2016 (Valentine!)
*/

#include "compile.h"

#define		PRIVATE		static

// e must be list  .. (list ex ex ...)
void outlist(int e){
	e = cdr(e);
	printf("(");
	while( cdr(e) != NIL ){
		pratom(car(e));
		printf(", ");
		e = cdr(e);
	}
	pratom(car(e));		// last item
	printf(")");
}

void genex(int x){
	int a, e;

	if( x == NIL ) return;
	if(isatom(x)){ pratom(x); return; }

	a = car(x);			// (op ex .. )
	e = cdr(x);			// e = (ex .. )
	if(car(a) != OPER)
		seterror("genex: expect operator");
	switch(cdr(a)){
	case tkAND:
	case tkOR:
		printf("LB (");
		printf("\n");
		printf("logic ");
		pratom(a);
		printf("\n");
		genex(car(e));
		printf("\n");
		genex(item2(e));
		printf("\n");
		printf("RB )");
		break;
	case tkEQ:
	case tkNE:
	case tkGT:
	case tkGE:
	case tkLT:
	case tkLE:
	case tkIS:
	case tkLIKE:
	case tkNLIKE:
		printf("name ");
		genex(car(e));
		printf("\n");
		printf("op ");
		pratom(a);
		printf("\n");
		printf("value ");
		genex(item2(e));
		break;
	case tkIN:
	case tkNIN:
		printf("name ");
		genex(car(e));
		printf("\n");
		printf("op ");
		pratom(a);
		printf("\n");
		printf("value ");
		outlist(item2(e));
		break;
	case tkBETWEEN:
	case tkNBET:
		printf("name ");
		genex(car(e));
		printf("\n");
		printf("op ");
		pratom(a);
		printf("\n");
		printf("value ");
		genex(item2(e));
		printf(" and ");
		genex(item3(e));
		break;
	case tkFUN:		// e = (name list)
		pratom(car(e));
		outlist(item2(e));
		break;

	default:
		seterror("unknown op\n");
	}
}
